#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
extern int inthp();
#define TRUE 1
#define FALSE 0
#define boolean unsigned short
//#define log(a) (a==0.0 ? -1e100 : log(a))

typedef struct helper_fmt
  {
    double *result;
    double theta;
    double ttratio;
    double t0;
    double *xxx1;
    double *xxx2;
    long *patsum;
    long *pattern;
    long nx;
    long sites;
    double basefreq[4];
    double weight;
    short final;
    double alpha;
    double alphapart;
    double rate;
  }
helper_fmt;


double phi (double t, void *b);
double phigamma (double t, void *b);


void read_data(char *file,char **s1, char **s2, long *loci,long *sites,double *xs,
double *xe,
double *xstep, double *ys, double *ye, double *ystep)
{
  FILE *fp;

  long i,z,j,dummy1;
  char *dummy3,*dummy4,ch;
  fp = fopen(file,"r");
  dummy3 = calloc(1,sizeof(char)*11000);
  dummy4 = calloc(1,sizeof(char)*11);
  *xe = 0; *xs=-5; *ys=-5; *ye=0; 
  *xstep=0.5; *ystep=0.1;
  fscanf(fp,"%ld%ld\n",&dummy1,loci);
  for(i=0;i<*loci;i++)
    fscanf(fp,"%ld",&(sites[i]));
  fgets(dummy3,1024,fp);  fgets(dummy3,1024,fp);
  for(i=0;i< *loci;i++)
    {
      for(j=0;j<2;j++)
	{
	  for(z=0;z<10;z++)
	    fgetc(fp);
	  z=0;
	  while(z<sites[i])
	    {
	      ch=fgetc(fp);
	      if(ch!='\n' && ch!=' ')
		{
		  if(j==0)
		    s1[i][z++] = ch;
		  else
		    s2[i][z++] = ch;
		}
	    }
	}
    }
  fclose(fp);
}



void read_data_old(char *file,char *s1, char *s2,long *sites,double *xs,
double *xe,
double *xstep, double *ys, double *ye, double *ystep)
{
  FILE *fp;
  fp = fopen(file,"r");
  fscanf(fp,"%lf%lf%lf%lf%lf%lf\n",xs,xe,xstep,ys,ye,ystep);
  fscanf(fp,"%s\n%s\n%li",s1,s2,sites);
  fclose(fp);
}



void 
nuview(double ttratio, double t1, double t2, long *pattern, double *xxx1, long nx1, double *xxx2, long nx2, 
		double *basefreq, long basen, double *result)
{
  short i;
  long z=0;
  double lw1, lw2, yy1, yy2, ww1zz1, vv1zz1, ww2zz2, vv2zz2, vzsumr1, vzsumr2,
    vzsumy1, vzsumy2, sum1, sum2, sumr1, sumr2, sumy1, sumy2, ww1, ww2,
    zz1, zz2;
  double freqa = basefreq[0];
  double freqc = basefreq[1];
  double freqg = basefreq[2];
  double freqt = basefreq[3];
  double freqar,freqgr, freqr, freqy, freqcy, freqty;
  double aa,bb, xi,xv,fracchange;
  
  double xx1[4],  xx2[4];
  freqr = freqa + freqg;
  freqy = freqc + freqt;
  freqar = freqa/ freqr;
  freqcy = freqc/ freqy;
  freqgr = freqg / freqr;
  freqty = freqt / freqy;
  aa = ttratio * (freqr) * (freqy)
    - freqa * freqg - freqc * freqt;
  bb = freqa * (freqgr) + freqc * (freqty);
  xi = aa / (aa + bb);
  xv = 1.0 - xi;
  fracchange=(xi) * (2 * freqa * (freqgr)
				 + 2 * freqc * (freqty)) +
    (xv) * (1.0 - freqa * freqa
		 - freqc * freqc - freqg
		 * freqg
		 - freqt * freqt);
  lw1 = -t1 / fracchange;
  ww1 = exp (xi * lw1);
  zz1 = exp (xv * lw1);
  ww1zz1 = ww1 * zz1;
  vv1zz1 = (1.0 - ww1) * zz1;
  lw2 = -t2 / fracchange;
  ww2 = exp (xi * lw2);
  zz2 = exp (xv * lw2);
  ww2zz2 = ww2 * zz2;
  vv2zz2 = (1.0 - ww2) * zz2;
  yy1 = 1.0 - zz1;
  yy2 = 1.0 - zz2;
  for (i = 0; i < 15; i++)
    {
      switch(i)
	{
	case 0: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=1;xx2[1]=0;xx2[2]=0;xx2[3]=0;break;
	case 1: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 2: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 3: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 4: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 5: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 6: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 7: xx1[0]=0;xx1[1]=0;xx1[2]=1;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 8: xx1[0]=0;xx1[1]=0;xx1[2]=1;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 9: xx1[0]=0;xx1[1]=0;xx1[2]=0;xx1[3]=1;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 10: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=1;xx2[1]=1;xx2[2]=1;xx2[3]=1;break;
	case 11: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=1;xx2[1]=0;xx2[2]=0;xx2[3]=0;break;
	case 12: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 13: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 14: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	}
      sum1 = yy1 * (freqa * xx1[0] + freqc * xx1[1] +
		    freqg * xx1[2] + freqt
		    * xx1[3]);
      sum2 = yy2 * (freqa * xx2[0] + freqc * xx2[1] +
		    freqg * xx2[2] + freqt
		    * xx2[3]);
      sumr1 = freqar * xx1[0] + freqgr * xx1[2];
      sumr2 = freqar * xx2[0] + freqgr * xx2[2];
      sumy1 = freqcy * xx1[1]
	+ freqty * xx1[3];
      sumy2 = freqcy * xx2[1]
	+  freqty * xx2[3];
      vzsumr1 = vv1zz1 * sumr1;
      vzsumr2 = vv2zz2 * sumr2;
      vzsumy1 = vv1zz1 * sumy1;
      vzsumy2 = vv2zz2 * sumy2;
      result[z] = (sum1 + ww1zz1 * xx1[0] + vzsumr1) *
	(sum2 + ww2zz2 * xx2[0] + vzsumr2) * freqa;
      result[z] +=
	(sum1 + ww1zz1 * xx1[1] + vzsumy1) *
	(sum2 + ww2zz2 * xx2[1] + vzsumy2) * freqc;
      result[z] +=
	(sum1 + ww1zz1 * xx1[2] + vzsumr1) *
	(sum2 + ww2zz2 * xx2[2] + vzsumr2) * freqg;
      result[z] +=
	(sum1 + ww1zz1 * xx1[3] + vzsumy1) *
	(sum2 + ww2zz2 * xx2[3] + vzsumy2) * freqt;
      z++;
    }
}


void conditional(char *seq1, char *seq2, long *patsum, long *pattern, long sites)
{
  long i,x;
  for(i=0;i<sites;i++)
    {
      switch(toupper(seq1[i]))
	{
	case 'A': x=1; break;
	case 'C': x=10; break;
	case 'G': x=100; break;
	case 'T': x=1000; break;
	case '-':
	case '?':
	default: x=1111; break;
	}
      switch(toupper(seq2[i]))
	{
	case 'A': x +=1; break;
	case 'C': x +=10; break;
	case 'G': x +=100; break;
	case 'T': x +=1000; break;
	case '-':
	case '?':
	default: x +=1111; break;
	}
      switch(x)
	{
      /*AA=2[0] AC=11[1] AG=101[2] AT=1001[3] 
	CC=20[4] CG=110[5] CT=1010[6] GG=200[7]
	GT=1100[8] TT=2000[9]*/
	case 2: patsum[0]++; pattern[i]=0;break;//aa
	case 11: patsum[1]++; pattern[i]=1; break;//ac
	case 101: patsum[2]++; pattern[i]=2; break;//ag
	case 1001: patsum[3]++; pattern[i]=3; break;//at
	case 20:  patsum[4]++; pattern[i]=4;break;//cc
	case 110:  patsum[5]++; pattern[i]=5;break;//cg
	case 1010: patsum[6]++;  pattern[i]=6;break;//ct
	case 200: patsum[7]++;  pattern[i]=7;break;//gg
	case 1100: patsum[8]++;  pattern[i]=8;break;//gt
	case 2000: patsum[9]++;  pattern[i]=9;break;//tt
	case 2222: patsum[10]++;  pattern[i]=10;break;//??
	case 1112: patsum[11]++;  pattern[i]=11;break;//?a
	case 1121: patsum[12]++;  pattern[i]=12;break;//?c
	case 1211: patsum[13]++;  pattern[i]=13;break;//?g
	case 2111: patsum[14]++;  pattern[i]=14;break;//?t
	default: exit(-1);
	}
    }
}

void conditional_old(char *seq, double *x, long sites)
{
  long i;
  for(i=0;i<sites;i++)
    {
      switch(toupper(seq[i]))
	{
	case 'A': x[i*4]=1; break;
	case 'C': x[i*4+1]=1; break;
	case 'G': x[i*4+2]=1; break;
	case 'T': x[i*4+3]=1; break;
	case '-':
	case '?':
	default:
	  x[i*4]=0.25; x[i*4+1]=0.25; 
	  x[i*4+2]=0.25; x[i*4+3]=0.25; break;
	}
    }
}

int main(int argc, char *argv[])
{

  long i,check=0, loci=1,ss;
  long sites[100];
  double maxweight=-1e100;
  static helper_fmt *helper;
  double theta;
  static double bottom,top;
  double oldres = -100;
  long m, inf=0, failinf, which,guardmax=1, guard=0;
  double result=0.0;
  double xb,xe,xstep,yb,ye,ystep;
  double a,b,d,p,eps;
  double highest=0;
  double lbottom,ltop;
  boolean single=FALSE;
  double singletheta=1;
  char **seq1, **seq2;
  boolean alloci=TRUE;
  char input[1024];
  // help part

  if(argc==1 || (argc > 1 && (!strcmp(argv[1],"-h") || !strcmp(argv[1],"--help"))))
    {
    fprintf(stderr,"Diverge3d: this program estimates ancestral Theta and divergence time gamma\n");
    fprintf(stderr,"using a ML method that is close to Yang (1998), but uses the F84 model\n");
    fprintf(stderr,"it will deliver only raw numbers (coordinates are {Theta,gamma,log(Likelihood)})\n");
    fprintf(stderr,"on a grid, and you need to transfer them\n");
    fprintf(stderr,"to a program that is capable to create a contour plot\n\n");
    fprintf(stderr,"Several possible syntax for diverge3d:\n");
    fprintf(stderr,"diverge3d -h                    this help\n\n");
    fprintf(stderr,"Known Theta:\ndiverge3d datafile s Theta-value  guardmax locus alpha > outfile\n");
    fprintf(stderr,"Estimate Theta and gamma:\ndiverge3d datafile + guardmax locus alpha > outfile\n");
    fprintf(stderr,"          datafile: contains the sequences in the migrate (Beerli 1999) format\n");
    fprintf(stderr,"          s: if this occurs the program assumes that Theta is constant\n");
    fprintf(stderr,"          Theta-value: a specific Theta value\n");
    fprintf(stderr,"          a: estimate divergence and theta for locus\n");
    fprintf(stderr,"          whichlocus\n");
    fprintf(stderr,"          +: estimate gamma and Theta\n");
    fprintf(stderr,"          guardmax: maximal number of trials to solve the integral\n");
    fprintf(stderr,"          locus: specifies which locus out of the dataset is used\n");
    fprintf(stderr,"          alpha: scale parameter alpha from a Gamma distribution\n"); 
    exit(-1);
    }

  // working parts

  helper = (helper_fmt *) calloc(1, sizeof(helper_fmt)*1);
  seq1= (char **) calloc(1,sizeof(char*)*100);
  seq2= (char **) calloc(1,sizeof(char*)*100);
  
  for(i=0;i<100;i++)
    {
      seq1[i] = (char *) calloc(1,3000*sizeof(char));
      seq2[i] = (char *) calloc(1,3000*sizeof(char));
    }
  read_data(argv[1],seq1,seq2, &loci, sites, &xb, &xe, &xstep, &yb, &ye, &ystep);
  fprintf(stderr,"Range for theta and tau\nIn log_10 [Range: %f-%f (stepsize: %f), range: %f-%f (stepsize: %f)]\n",
  	  xb,xe,xstep,yb,ye,ystep);
  fgets(input,1024,stdin);
  if ((input[0]!='\0')&&(input[0]!='\n'))
    {
     sscanf(input,"%lf%lf%lf%lf%lf%lf",&xb,&xe,&xstep,&yb,&ye,&ystep);
    }
  ss=0;
  for(i=0;i<loci;i++)
    {
      if(sites[i]>ss)
	ss=sites[i];
    }
  helper->patsum = (long *) calloc(1,sizeof(long)*15);
  helper->pattern = (long *) calloc(1,sizeof(long)*ss*4);
  helper->xxx1 = (double *) calloc(1,sizeof(double)*ss*4);
  helper->xxx2 = (double *) calloc(1,sizeof(double)*ss*4);
  helper->result = (double *) calloc(1,sizeof(double) * ss * 4);
  if(argv[2][0]=='s')
    {
      single=TRUE;
      singletheta = atof(argv[3]);
    }
  which=0;
  alloci=TRUE;
  if(argc>4)
    {
      alloci=FALSE;
      if(single)
	which = atoi(argv[5]);
      else
	which = atoi(argv[4]);
    }
  for(i=which;i<loci;i++)
    {
      maxweight=-1e100;
      helper->sites= sites[i];
      conditional(seq1[i],seq2[i],helper->patsum,helper->pattern,helper->sites);
      helper->ttratio=2.0;

      helper->nx = 15;
      helper->basefreq[0] = 0.25;
      helper->basefreq[1] = 0.25;
      helper->basefreq[2] = 0.25;
      helper->basefreq[3] = 0.25;
      
      helper->weight=0.;
      helper->final=0;
      if(argc>2){
	if(argv[2][0]=='+')
	  check=0;
	else 
	  {
	    check=0;
	  }
      }
      else
	{
	  check=0;
	}
      
      if((argc<=2) || check)
	{
	}
      else
	{
	  if(single)
	    {
	      guardmax=atof(argv[4]);	      
	    }
	  else
	    {
	      maxweight=atof(argv[2]);
	      if(argc>=4)
		guardmax=atof(argv[3]);
	    }
	}
      if(single)
	{
	  if(argc==7)
	    helper->alpha = atof(argv[6]);
	  else
	    helper->alpha = 10.;
	}
      else
	{
	  if(argc==6)
	    helper->alpha = atof(argv[5]);
	  else
	    helper->alpha = 10.;
	}
      helper->alphapart = log(helper->alpha) * helper->alpha - lgamma(helper->alpha);
      helper->weight= -100000;
      helper->final=1;
      for(theta=xb;theta<xe+xstep;theta += xstep)
	{
	  if(single)
	    helper->theta = singletheta;
	  else
	    helper->theta = pow(10.,theta);
	  for(helper->t0=pow(10.,yb);helper->t0<pow(10.,ye+ystep);
	      helper->t0 = pow(10,log10(helper->t0)+ystep))
	    {
	      bottom= -5000;
	      lbottom=0;
	      ltop=1e10;
	      top =  -10;
	      helper->weight=bottom;
	      guard=0;
	      result=-10;
	      highest=0;
	      goto xx;
	      while(guard++ < guardmax)
		{
		  if(helper->weight<bottom+1)
		    bottom -= bottom;
		  if(guard>4 && result > highest && finite(result) && inf==0)
		    highest =result;
		  if(result>1e-1 && result<1e10 && inf==0)
		    break;
		  else
		    {
		      if(isnan(result))
			{
			  //bottom +=(helper->weight-bottom)/2.;
			 bottom = helper->weight;
			  lbottom = result;
			  goto xx ;
			}
		      if(isinf(result)>0)
			{
			  bottom  = helper->weight;
			  //bottom +=(helper->weight-bottom)/2.;
			  lbottom = result;
			  goto xx ;
			}
		   
		      if(isinf(result)<0)
			{
			  top=helper->weight;
			  //top -=(top-helper->weight)/2.;			 
			  ltop = result;
			  goto xx ;
			}
		      if(result==0 && inf==4)
			{
			  bottom=helper->weight;
			  //top -=(top-helper->weight)/2.;			 
			  ltop = result;
			  goto xx ;
			}
			
		      if(finite(result))
			 {
			   if(result > 1)
			     {
			       //bottom +=(helper->weight-bottom)/2.;
			       bottom=helper->weight;
			       lbottom=result;
			       goto xx;
			     }
			   if(result < 1)
			     {
			       //top -=(top-helper->weight)/2.;
			       top=helper->weight;
			       ltop = result;
			       goto xx;
			     }
			 }
		    }
		xx:
		  /* if((fabs(bottom-top)<0.001))
		    {
		      bottom -= 10;
		      top += 12;
		      }*/
		  helper->weight = bottom + (top - bottom)/2.;
		  // while(TRUE)
		  //  {
		  //    helper->weight -= 1;
		  a = 0.0;
		  b = 1000.;
		  d = 1.0;
		  p = 1.;
		  eps = 10e-10;
		  m = 10000;
		  failinf=inf;
		  inf = 4;
		  if((oldres>result && result > 1e10) || (oldres<result && result < 1e-1))
		    oldres = result;
		  result =0.;
		  inthp (&a, &b, &d, phigamma, &m, &p, &eps, &inf, 
			 (void *) (helper), &result);
		}
		  fprintf(stderr,"**%li:%2li %g %g %10.10g %g  {%g %10.10g %g} %li %li\n ",
			  i, guard, helper->theta,
			  helper->t0,result,log(result)+helper->weight, bottom, helper->weight, top, inf, m);
		
	      //	}
	      if(guard>=guardmax)
		result=highest;
	  fprintf(stdout,"%20.20g %20.20g %20.20g\n ",
		  helper->theta,
			  helper->t0,log(result)+helper->weight);		  
	    }
	  if(single)
	    break;
	}
      if(alloci==FALSE)
	break;
    }
  return 0;
}
  
  
double
phigamma (double t, void *b)
{
  long i;
  double result=0.,alpha;
  double a,bb,eps, p, d;
  long inf,m;
  helper_fmt *helper;
  helper = (helper_fmt *) b;
  alpha = helper->alpha;
  a = 0.0;
  bb = 1000.;
  d = 1.0;
  p = 1.;
  eps = 10e-10;
  m = 10000;
  inf = 4;
  result=0;
  helper->rate = t;
  inthp (&a, &bb, &d, phi, &m, &p, &eps, &inf, 
	 (void *) (helper), &result);
  result *= exp(helper->alphapart + log(t) * (alpha - 1.) - t * alpha) ;
  return result;
}

  
double
phi (double t, void *b)
{
  long i;
  double result=0.,temp=0, ttt;
  helper_fmt *helper;
  helper = (helper_fmt *) b;
  ttt = t +helper->t0*helper->rate;
  nuview(helper->ttratio, ttt, ttt, helper->pattern, helper->xxx1, helper->sites, 
	 helper->xxx2, helper->sites, helper->basefreq, 4,helper->result);
  
  for(i=0;i<helper->nx;i++)
    {
      if(helper->patsum[i]!=0)
	result += log(helper->result[i])*helper->patsum[i];
    }
  //  fprintf(stderr, "%f ", result);
  temp =  2. / (helper->rate * helper->theta); 
  result += -t *temp  + log(temp);
  return (exp(result-helper->weight));
}














